# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/hibernate-annotations/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define section free

%define reltag GA.patch02
%define hname hibernate-annotations

Summary:        Relational persistence and query service
Name:           hibernate3-annotations
Version:        3.2.1
Release:        1.patch02.1jpp.ep1.2%{?dist}.1
Epoch:          0
License:        LGPL
URL:            http://annotations.hibernate.org/
Group:          Database
Source0:        http://prdownloads.sourceforge.net/hibernate/hibernate-annotations-3.2.1.GA.tar.gz
Source1:	hibernate-annotations-jdstyle.css
Source2:	hibernate-annotations-component-info.xml

Patch0:         hibernate-annotations-common-build_xml.patch
Patch1:         hibernate-annotations-ANN-551.patch
Patch2:         hibernate-annotations-ANN-556.patch


BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  antlr
BuildRequires:  cglib
BuildRequires:  dom4j
BuildRequires:  geronimo-jta-1.0.1B-api
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-collections
BuildRequires:  javassist
BuildRequires:  junit
BuildRequires:  hibernate3 >= 0:3.2
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:3.2.1
BuildRequires:  hsqldb
BuildRequires:  lucene >= 0:1.9.1

Requires:  java >= 0:1.5
# EAP only - The environment will need to provide a compatible hibernate
#Requires:  hibernate3 >= 0:3.2
Requires:  hibernate3-ejb-persistence-3.0-api >= 0:3.2.1
# FIXME Why would Lucene be needed at run-time for?  An Optional?
#Requires:  lucene
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate, like all other object/relational mapping tools, 
requires metadata that governs the transformation of data 
from one representation to the other (and vice versa). In 
Hibernate 2.x, mapping metadata is most of the time declared 
in XML text files. Another option is XDoclet, utilizing 
Javadoc source code annotations and a preprocessor at compile 
time.
The same kind of annotation support is now available in the 
standard JDK, although more powerful and better supported by 
tools. IntelliJ IDEA, for example, supports auto-completion 
and syntax highlighting of JDK 5.0 annotations. The EJB3 
specification standardizes the basic APIs and the metadata 
(using JDK 5.0 annotations) needed for any object/relational 
persistence mechanism. Hibernate EntityManager for EJB3 
implements the programming interfaces and lifecycle rules as 
defined by the EJB3 persistence specification. Both Hibernate 
EntityManager and Hibernate Annotations are available in 
standalone preview releases, however, they require Hibernate 
3.1 and JDK 5.0. If you are not using EJB3 persistence, 
please continue using Hibernate 3.0.x (with any JDK supported).
The Hibernate Annotations package provides annotations for
Standard JSR-220 defined O/R mapping
Hibernate O/R mapping extensions
Data validation via the Hibernate Validator framework

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{hname}-%{version}.GA
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done
mkdir test_output
cp %{SOURCE1} doc/api/jdstyle.css


%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%build
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
build-jar-repository -s -p . \
hibernate3

build-jar-repository -s -p lib \
antlr \
cglib-nodep \
commons-collections \
commons-logging \
dom4j \
hibernate3 \
hibernate3-ejb-persistence-3.0-api \
javassist \
jta \
lucene \

mkdir jdbc
build-jar-repository -s -p jdbc hsqldb

ant \
	-Dhibernate-core.home=. \
	-Djdk15.home=/usr/lib/jvm/java-1.5.0 \
	jar javadoc junitinstrument junit

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{hname}/%{hname}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && ln -sf %{name}.jar hibernate-annotations.jar)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH2} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/hibernate-annotations.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}



%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Sun Jan 27 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch02.1jpp.ep1.2.1
- Rebuild for RHEL-5

* Sun Jan 27 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch02.1jpp.ep1.2
- Add compatible line

* Fri Jan 25 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch02.1jpp.ep1.1
- Add patch for ANN-556

* Mon Sep 10 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch01.1jpp.ep1.3
- Require Lucene to be at least 1.9.1

* Fri Sep 07 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch01.1jpp.ep1.2
- Relax dependency on hibernate3 core (environment provides it on EAP)
- Remove run-time dependency on Lucene

* Fri Aug 24 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1.patch01.1jpp.ep1.1
- Patch for ANN-551

* Fri Aug 10 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.2.1-1jpp.ep1.4
- Fix typo in component-info.xml

* Fri Aug 10 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.2.1-1jpp.ep1.3
- Add repolib support

* Fri Aug 10 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.2.1-1jpp.ep1.2
- Add a link for hibernate-annotations.jar

* Thu Aug 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp.ep1.1
- Merge with upstream

* Thu Aug 09 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.2.1-1jpp
- Update to 3.2.1.GA
- Add missing BRs for hsqldb, junit and ant-junit

* Wed Aug 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.2.0-0.cr1.2jpp_1rh
- First Red Hat build

* Tue Aug 02 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.2.0-0.cr1.2jpp
- Activate unit tests
- Use rpm installed hibernate3 and dependency libraries

* Wed Jun 21 2006 Ralph Apel <r.apel at r-apel.de> - 0:3.2.0-0.cr1.1jpp
- First JPP-5.0 release

* Tue Sep 20 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.0-0.b2.1jpp
- First JPackage release
